//+------------------------------------------------------------------+
//|                                                       iTrend.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_width1 3
#property indicator_color2 Red
#property indicator_width2 3
#property indicator_color3 Magenta
#property indicator_style3 STYLE_DASH




extern int    Length            = 45;    // nonlag ma 
extern int    Price             = 0;     // =0-3 PRICE_CLOSE,PRICE_OPEN,PRICE_HIGH,PRICE_LOW
extern int    LevelBars         = 300;
extern double LevelFactor       = 0.125; // regular itrend is .283


double value[];
double value2[];
double ItrendLevel[];

double alphas[];


int init()
  {

   SetIndexBuffer(0,value);      SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,value2);     SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,ItrendLevel);
   
   IndicatorShortName("nonlag itrend");
   
   return(0);
  }

int start()
  {
   
  int    limit, i, r; 
  int    counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--;
  limit = MathMin(Bars-counted_bars,Bars-1);
           
  for (i=limit; i>=0; i--)
  {
  double CurrentPrice = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);
  double NLMA         = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,alphas,0,i);
  value[i]            = CurrentPrice-NLMA;
  value2[i]           = -((Low[i] - NLMA) + (High[i]- NLMA));   
  double high         = MathMax(value[ArrayMaximum(value,LevelBars,i)],value2[ArrayMaximum(value2,LevelBars,i)]);
  ItrendLevel[i]      = high*LevelFactor; 
  }  
  SetLevelValue(0, ItrendLevel[0]);
   
  return(0);
}


double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2



double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}